module FSM(HR, HY, HG, FR, FY, FG, ST, TS, TL, C, reset, clock);
output HR;
output HY;
output HG;
output FR;
output FY;
output FG;
output ST;
input TS;
input TL;
input C;
input reset;
input clock;
reg [6:1] state;
reg ST;

parameter highwaygreen = 6'b001100;
parameter highwayyellow = 6'b010100;
parameter farmroadgreen = 6'b100001;
parameter farmroadyellow = 6'b100010;

assign HR = state[6];
assign HY = state[5];
assign HG = state[4];
assign FR = state[3];
assign FY = state[2];
assign FG = state[1];

initial begin
    state = highwaygreen;
    ST = 0;
end

always @(posedge clock) begin
    if (reset) begin
        state = highwaygreen;
        ST = 1;
    end
    else begin
        ST = 0;
        case (state)
            highwaygreen:
                if (TL & C) begin
                    state = highwayyellow;
                    ST = 1;
                end
            highwayyellow:
                if (TS) begin
                    state = farmroadgreen;
                    ST = 1;
                end
            farmroadgreen:
                if (TL | !C) begin
                    state = farmroadyellow;
                    ST = 1;
                end
            farmroadyellow:
                if (TS) begin
                    state = highwaygreen;
                    ST = 1;
                end
        endcase
    end
end
endmodule

module Timer(TS, TL, ST, clock);
output TS;
output TL;
input ST;
input clock;
integer value;

assign TS = (value > 4);       //  5 cycles after reset
assign TL = (value > 19);      // 20 cycles after reset

always @(posedge ST)
    value = 0; // async reset

always @(posedge clock)
    value = value + 1;

endmodule

    // module traffic_light(HR, HY, HG, FR, FY, FG, reset, C, clock);
    //   output HR, HY, HG, FR, FY, FG;
    //   input reset, C, clock;
    //
    //   Timer part1(TS, TL, ST, clock);
    //   FSM part2(HR, HY, HG, FR, FY, FG, ST, TS, TL, C, reset, clock);
    // endmodule
